
(define
	(domain barman)
	(:requirements
		:strips :typing
	)
	(:types
		hand level beverage dispenser container - object
		ingredient cocktail - beverage
		shot shaker - container
	)
	(:predicates
		(ontable ?c - container)
		(holding ?h - hand ?c - container)
		(handempty ?h - hand)
		(empty ?c - container)
		(contains ?c - container ?b - beverage)
		(clean ?c - container)
		(used ?c - container ?b - beverage)
		(dispenses ?d - dispenser ?i - ingredient)
		(shaker-empty-level ?s - shaker ?l - level)
		(shaker-level ?s - shaker ?l - level)
		(next ?l1 ?l2 - level)
		(unshaked ?s - shaker)
		(shaked ?s - shaker)
		(cocktail-part1 ?c - cocktail ?i - ingredient)
		(cocktail-part2 ?c - cocktail ?i - ingredient)
	)
	(:action grasp
		:parameters (?h - hand ?c - container)
		:precondition
			(and
				(ontable ?c)
				(handempty ?h)
			)
		:effect
			(and
				(not (ontable ?c))
				(not (handempty ?h))
				(holding ?h ?c)
			)
	)
	(:action leave
		:parameters (?h - hand ?c - container)
		:precondition
			(and (holding ?h ?c))
		:effect
			(and
				(not (holding ?h ?c))
				(handempty ?h)
				(ontable ?c)
			)
	)
	(:action fill-shot
		:parameters (?s - shot ?i - ingredient ?h1 ?h2 - hand
			?d - dispenser)
		:precondition
			(and
				(holding ?h1 ?s)
				(handempty ?h2)
				(dispenses ?d ?i)
				(empty ?s)
				(clean ?s)
			)
		:effect
			(and
				(not (empty ?s))
				(contains ?s ?i)
				(not (clean ?s))
				(used ?s ?i)
			)
	)
	(:action refill-shot
		:parameters (?s - shot ?i - ingredient ?h1 ?h2 - hand
			?d - dispenser)
		:precondition
			(and
				(holding ?h1 ?s)
				(handempty ?h2)
				(dispenses ?d ?i)
				(empty ?s)
				(used ?s ?i)
			)
		:effect
			(and
				(not (empty ?s))
				(contains ?s ?i)
			)
	)
	(:action empty-shot
		:parameters (?h - hand ?p - shot ?b - beverage)
		:precondition
			(and
				(holding ?h ?p)
				(contains ?p ?b)
			)
		:effect
			(and
				(not (contains ?p ?b))
				(empty ?p)
			)
	)
	(:action clean-shot
		:parameters (?s - shot ?b - beverage ?h1 ?h2 - hand)
		:precondition
			(and
				(holding ?h1 ?s)
				(handempty ?h2)
				(empty ?s)
				(used ?s ?b)
			)
		:effect
			(and
				(not (used ?s ?b))
				(clean ?s)
			)
	)
	(:action pour-shot-to-clean-shaker
		:parameters (?s - shot ?i - ingredient ?d - shaker ?h1 - hand
			?l ?l1 - level)
		:precondition
			(and
				(holding ?h1 ?s)
				(contains ?s ?i)
				(empty ?d)
				(clean ?d)
				(shaker-level ?d ?l)
				(next ?l ?l1)
			)
		:effect
			(and
				(not (contains ?s ?i))
				(empty ?s)
				(contains ?d ?i)
				(not (empty ?d))
				(not (clean ?d))
				(unshaked ?d)
				(not (shaker-level ?d ?l))
				(shaker-level ?d ?l1)
			)
	)
	(:action pour-shot-to-used-shaker
		:parameters (?s - shot ?i - ingredient ?d - shaker ?h1 - hand
			?l ?l1 - level)
		:precondition
			(and
				(holding ?h1 ?s)
				(contains ?s ?i)
				(unshaked ?d)
				(shaker-level ?d ?l)
				(next ?l ?l1)
			)
		:effect
			(and
				(not (contains ?s ?i))
				(contains ?d ?i)
				(empty ?s)
				(not (shaker-level ?d ?l))
				(shaker-level ?d ?l1)
			)
	)
	(:action empty-shaker
		:parameters (?h - hand ?s - shaker ?b - cocktail ?l
			?l1 - level)
		:precondition
			(and
				(holding ?h ?s)
				(contains ?s ?b)
				(shaked ?s)
				(shaker-level ?s ?l)
				(shaker-empty-level ?s ?l1)
			)
		:effect
			(and
				(not (shaked ?s))
				(not (shaker-level ?s ?l))
				(shaker-level ?s ?l1)
				(not (contains ?s ?b))
				(empty ?s)
			)
	)
	(:action clean-shaker
		:parameters (?h1 ?h2 - hand ?s - shaker)
		:precondition
			(and
				(holding ?h1 ?s)
				(handempty ?h2)
				(empty ?s)
			)
		:effect
			(and (clean ?s))
	)
	(:action shake
		:parameters (?b - cocktail ?d1 ?d2 - ingredient ?s - shaker
			?h1 ?h2 - hand)
		:precondition
			(and
				(holding ?h1 ?s)
				(handempty ?h2)
				(contains ?s ?d1)
				(contains ?s ?d2)
				(cocktail-part1 ?b ?d1)
				(cocktail-part2 ?b ?d2)
				(unshaked ?s)
			)
		:effect
			(and
				(not (unshaked ?s))
				(not (contains ?s ?d1))
				(not (contains ?s ?d2))
				(shaked ?s)
				(contains ?s ?b)
			)
	)
	(:action pour-shaker-to-shot
		:parameters (?b - beverage ?d - shot ?h - hand ?s - shaker
			?l ?l1 - level)
		:precondition
			(and
				(holding ?h ?s)
				(shaked ?s)
				(empty ?d)
				(clean ?d)
				(contains ?s ?b)
				(shaker-level ?s ?l)
				(next ?l1 ?l)
			)
		:effect
			(and
				(not (clean ?d))
				(not (empty ?d))
				(contains ?d ?b)
				(shaker-level ?s ?l1)
				(not (shaker-level ?s ?l))
			)
	)
;|	(:macro
		(:action chunk-22-3
			:parameters (?right - hand ?shaker1 - shaker ?cocktail1 - cocktail ?l1
				?l0 - level ?left - hand)
			:precondition
				(and
					(holding ?right ?shaker1)
					(contains ?shaker1 ?cocktail1)
					(shaked ?shaker1)
					(shaker-level ?shaker1 ?l1)
					(shaker-empty-level ?shaker1 ?l0)
					(handempty ?left)
				)
			:effect
				(and
					(not (shaked ?shaker1))
					(not (shaker-level ?shaker1 ?l1))
					(shaker-level ?shaker1 ?l0)
					(not (contains ?shaker1 ?cocktail1))
					(empty ?shaker1)
					(clean ?shaker1)
				)
;|			:permutation
;|				(empty-shaker ?right ?shaker1 ?cocktail1 ?l1 ?l0)
;|				(clean-shaker ?right ?left ?shaker1)
		)
;|	)
;|	(:macro
		(:action chunk-18-1
			:parameters (?left - hand ?shot2 ?shot5 - shot ?ingredient1 - ingredient
				?right - hand ?dispenser1 - dispenser)
			:precondition
				(and
					(holding ?left ?shot2)
					(ontable ?shot5)
					(handempty ?right)
					(dispenses ?dispenser1 ?ingredient1)
					(empty ?shot5)
					(clean ?shot5)
				)
			:effect
				(and
					(not (holding ?left ?shot2))
					(ontable ?shot2)
					(not (ontable ?shot5))
					(holding ?left ?shot5)
					(not (empty ?shot5))
					(contains ?shot5 ?ingredient1)
					(not (clean ?shot5))
					(used ?shot5 ?ingredient1)
				)
;|			:permutation
;|				(leave ?left ?shot2)
;|				(grasp ?left ?shot5)
;|				(fill-shot ?shot5 ?ingredient1 ?left ?right ?dispenser1)
		)
;|	)
;|	(:macro
		(:action chunk-48-3
			:parameters (?left - hand ?shot2 - shot ?right - hand ?shaker1 - shaker
				?ingredient2 - ingredient ?dispenser2 - dispenser)
			:precondition
				(and
					(ontable ?shot2)
					(handempty ?left)
					(holding ?right ?shaker1)
					(empty ?shot2)
					(used ?shot2 ?ingredient2)
					(dispenses ?dispenser2 ?ingredient2)
				)
			:effect
				(and
					(not (empty ?shot2))
					(contains ?shot2 ?ingredient2)
				)
;|			:permutation
;|				(grasp ?left ?shot2)
;|				(leave ?right ?shaker1)
;|				(clean-shot ?shot2 ?ingredient2 ?left ?right)
;|				(fill-shot ?shot2 ?ingredient2 ?left ?right ?dispenser2)
;|				(grasp ?right ?shaker1)
;|				(leave ?left ?shot2)
		)
;|	)
;|	(:macro
		(:action chunk-1-4
			:parameters (?right - hand ?shot6 - shot ?shaker1 - shaker)
			:precondition
				(and
					(holding ?right ?shot6)
					(ontable ?shaker1)
				)
			:effect
				(and
					(not (holding ?right ?shot6))
					(ontable ?shot6)
					(not (ontable ?shaker1))
					(holding ?right ?shaker1)
				)
;|			:permutation
;|				(leave ?right ?shot6)
;|				(grasp ?right ?shaker1)
		)
;|	)
)

