
(define
	(domain depots)
	(:requirements
		:strips :typing
	)
	(:types
		place locatable - object
		depot distributor - place
		truck hoist surface - locatable
		pallet crate - surface
	)
	(:predicates
		(at ?x - locatable ?y - place)
		(on ?x - crate ?y - surface)
		(in ?x - crate ?y - truck)
		(lifting ?x - hoist ?y - crate)
		(available ?x - hoist)
		(clear ?x - surface)
	)
	(:action drive
		:parameters (?x - truck ?y ?z - place)
		:precondition
			(and (at ?x ?y))
		:effect
			(and
				(not (at ?x ?y))
				(at ?x ?z)
			)
	)
	(:action lift
		:parameters (?x - hoist ?y - crate ?z - surface ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(available ?x)
				(at ?y ?p)
				(on ?y ?z)
				(clear ?y)
			)
		:effect
			(and
				(not (at ?y ?p))
				(lifting ?x ?y)
				(not (clear ?y))
				(not (available ?x))
				(clear ?z)
				(not (on ?y ?z))
			)
	)
	(:action drop
		:parameters (?x - hoist ?y - crate ?z - surface ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(clear ?z)
				(lifting ?x ?y)
			)
		:effect
			(and
				(available ?x)
				(not (lifting ?x ?y))
				(at ?y ?p)
				(not (clear ?z))
				(clear ?y)
				(on ?y ?z)
			)
	)
	(:action load
		:parameters (?x - hoist ?y - crate ?z - truck ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(lifting ?x ?y)
			)
		:effect
			(and
				(not (lifting ?x ?y))
				(in ?y ?z)
				(available ?x)
			)
	)
	(:action unload
		:parameters (?x - hoist ?y - crate ?z - truck ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(available ?x)
				(in ?y ?z)
			)
		:effect
			(and
				(not (in ?y ?z))
				(not (available ?x))
				(lifting ?x ?y)
			)
	)
;|	(:macro
		(:action chunk-0-3-12
			:parameters (?hoist5 - hoist ?crate8 - crate ?truck1 - truck ?distributor2 - distributor
				?crate6 - crate)
			:precondition
				(and
					(at ?hoist5 ?distributor2)
					(at ?truck1 ?distributor2)
					(available ?hoist5)
					(in ?crate8 ?truck1)
					(clear ?crate6)
					(at ?crate6 ?distributor2)
				)
			:effect
				(and
					(not (in ?crate8 ?truck1))
					(at ?crate8 ?distributor2)
					(not (clear ?crate6))
					(clear ?crate8)
					(on ?crate8 ?crate6)
				)
;|			:permutation
;|				(unload ?hoist5 ?crate8 ?truck1 ?distributor2)
;|				(drop ?hoist5 ?crate8 ?crate6 ?distributor2)
		)
;|	)
;|	(:macro
		(:action chunk-38-4-313
			:parameters (?truck0 - truck ?depot0 - depot ?distributor0 - distributor ?depot1 - depot
				?distributor2 - distributor)
			:precondition
				(and
					(at ?truck0 ?depot0)
					(at ?truck0 ?depot1)
				)
			:effect
				(and
					(not (at ?truck0 ?depot1))
					(at ?truck0 ?distributor2)
				)
;|			:permutation
;|				(drive ?truck0 ?depot0 ?distributor0)
;|				(drive ?truck0 ?depot1 ?depot0)
;|				(drive ?truck0 ?distributor0 ?distributor2)
		)
;|	)
)

