
(define
	(domain depots)
	(:requirements
		:strips :typing
	)
	(:types
		place locatable - object
		depot distributor - place
		truck hoist surface - locatable
		pallet crate - surface
	)
	(:predicates
		(at ?x - locatable ?y - place)
		(on ?x - crate ?y - surface)
		(in ?x - crate ?y - truck)
		(lifting ?x - hoist ?y - crate)
		(available ?x - hoist)
		(clear ?x - surface)
	)
	(:action drive
		:parameters (?x - truck ?y ?z - place)
		:precondition
			(and (at ?x ?y))
		:effect
			(and
				(not (at ?x ?y))
				(at ?x ?z)
			)
	)
	(:action lift
		:parameters (?x - hoist ?y - crate ?z - surface ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(available ?x)
				(at ?y ?p)
				(on ?y ?z)
				(clear ?y)
			)
		:effect
			(and
				(not (at ?y ?p))
				(lifting ?x ?y)
				(not (clear ?y))
				(not (available ?x))
				(clear ?z)
				(not (on ?y ?z))
			)
	)
	(:action drop
		:parameters (?x - hoist ?y - crate ?z - surface ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(clear ?z)
				(lifting ?x ?y)
			)
		:effect
			(and
				(available ?x)
				(not (lifting ?x ?y))
				(at ?y ?p)
				(not (clear ?z))
				(clear ?y)
				(on ?y ?z)
			)
	)
	(:action load
		:parameters (?x - hoist ?y - crate ?z - truck ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(lifting ?x ?y)
			)
		:effect
			(and
				(not (lifting ?x ?y))
				(in ?y ?z)
				(available ?x)
			)
	)
	(:action unload
		:parameters (?x - hoist ?y - crate ?z - truck ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(available ?x)
				(in ?y ?z)
			)
		:effect
			(and
				(not (in ?y ?z))
				(not (available ?x))
				(lifting ?x ?y)
			)
	)
;|	(:macro
		(:action chunk-0-4-10
			:parameters (?hoist0 - hoist ?crate4 ?crate2 - crate ?depot0 - depot
				?truck0 - truck)
			:precondition
				(and
					(at ?hoist0 ?depot0)
					(available ?hoist0)
					(at ?crate4 ?depot0)
					(on ?crate4 ?crate2)
					(clear ?crate4)
					(at ?truck0 ?depot0)
				)
			:effect
				(and
					(not (at ?crate4 ?depot0))
					(not (clear ?crate4))
					(clear ?crate2)
					(not (on ?crate4 ?crate2))
					(in ?crate4 ?truck0)
				)
;|			:permutation
;|				(lift ?hoist0 ?crate4 ?crate2 ?depot0)
;|				(load ?hoist0 ?crate4 ?truck0 ?depot0)
		)
;|	)
;|	(:macro
		(:action chunk-8-5-60
			:parameters (?hoist3 - hoist ?crate4 - crate ?truck0 - truck ?distributor0 - distributor
				?hoist0 - hoist ?depot0 - depot)
			:precondition
				(and
					(at ?hoist3 ?distributor0)
					(at ?truck0 ?distributor0)
					(available ?hoist3)
					(in ?crate4 ?truck0)
					(at ?hoist0 ?depot0)
					(at ?truck0 ?depot0)
					(lifting ?hoist0 ?crate4)
				)
			:effect
				(and
					(not (available ?hoist3))
					(lifting ?hoist3 ?crate4)
					(not (lifting ?hoist0 ?crate4))
					(available ?hoist0)
				)
;|			:permutation
;|				(unload ?hoist3 ?crate4 ?truck0 ?distributor0)
;|				(load ?hoist0 ?crate4 ?truck0 ?depot0)
		)
;|	)
;|	(:macro
		(:action chunk-22-5-168
			:parameters (?truck0 - truck ?distributor0 ?distributor1 - distributor ?hoist3 - hoist
				?crate4 - crate ?depot0 - depot)
			:precondition
				(and
					(at ?truck0 ?distributor0)
					(at ?hoist3 ?distributor1)
					(lifting ?hoist3 ?crate4)
				)
			:effect
				(and
					(not (at ?truck0 ?distributor0))
					(not (lifting ?hoist3 ?crate4))
					(in ?crate4 ?truck0)
					(available ?hoist3)
					(at ?truck0 ?depot0)
				)
;|			:permutation
;|				(drive ?truck0 ?distributor0 ?distributor1)
;|				(load ?hoist3 ?crate4 ?truck0 ?distributor1)
;|				(drive ?truck0 ?distributor1 ?depot0)
		)
;|	)
;|	(:macro
		(:action chunk-31-4-242
			:parameters (?truck0 - truck ?depot0 ?depot1 - depot ?hoist1 - hoist
				?crate3 - crate ?distributor0 - distributor)
			:precondition
				(and
					(at ?truck0 ?depot0)
					(at ?hoist1 ?depot1)
					(lifting ?hoist1 ?crate3)
				)
			:effect
				(and
					(not (at ?truck0 ?depot0))
					(not (lifting ?hoist1 ?crate3))
					(in ?crate3 ?truck0)
					(available ?hoist1)
					(at ?truck0 ?distributor0)
				)
;|			:permutation
;|				(drive ?truck0 ?depot0 ?depot1)
;|				(load ?hoist1 ?crate3 ?truck0 ?depot1)
;|				(drive ?truck0 ?depot1 ?distributor0)
		)
;|	)
)

