
(define
	(domain depots)
	(:requirements
		:strips :typing
	)
	(:types
		place locatable - object
		depot distributor - place
		truck hoist surface - locatable
		pallet crate - surface
	)
	(:predicates
		(at ?x - locatable ?y - place)
		(on ?x - crate ?y - surface)
		(in ?x - crate ?y - truck)
		(lifting ?x - hoist ?y - crate)
		(available ?x - hoist)
		(clear ?x - surface)
	)
	(:action drive
		:parameters (?x - truck ?y ?z - place)
		:precondition
			(and (at ?x ?y))
		:effect
			(and
				(not (at ?x ?y))
				(at ?x ?z)
			)
	)
	(:action lift
		:parameters (?x - hoist ?y - crate ?z - surface ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(available ?x)
				(at ?y ?p)
				(on ?y ?z)
				(clear ?y)
			)
		:effect
			(and
				(not (at ?y ?p))
				(lifting ?x ?y)
				(not (clear ?y))
				(not (available ?x))
				(clear ?z)
				(not (on ?y ?z))
			)
	)
	(:action drop
		:parameters (?x - hoist ?y - crate ?z - surface ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(clear ?z)
				(lifting ?x ?y)
			)
		:effect
			(and
				(available ?x)
				(not (lifting ?x ?y))
				(at ?y ?p)
				(not (clear ?z))
				(clear ?y)
				(on ?y ?z)
			)
	)
	(:action load
		:parameters (?x - hoist ?y - crate ?z - truck ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(lifting ?x ?y)
			)
		:effect
			(and
				(not (lifting ?x ?y))
				(in ?y ?z)
				(available ?x)
			)
	)
	(:action unload
		:parameters (?x - hoist ?y - crate ?z - truck ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(available ?x)
				(in ?y ?z)
			)
		:effect
			(and
				(not (in ?y ?z))
				(not (available ?x))
				(lifting ?x ?y)
			)
	)
;|	(:macro
		(:action chunk-39-1
			:parameters (?truck1 - truck ?distributor1 - distributor ?depot2 - depot ?hoist2 - hoist
				?crate9 - crate)
			:precondition
				(and
					(at ?truck1 ?distributor1)
					(at ?hoist2 ?depot2)
					(lifting ?hoist2 ?crate9)
				)
			:effect
				(and
					(not (lifting ?hoist2 ?crate9))
					(in ?crate9 ?truck1)
					(available ?hoist2)
				)
;|			:permutation
;|				(drive ?truck1 ?distributor1 ?depot2)
;|				(load ?hoist2 ?crate9 ?truck1 ?depot2)
;|				(drive ?truck1 ?depot2 ?distributor1)
		)
;|	)
;|	(:macro
		(:action chunk-33-0
			:parameters (?truck1 - truck ?distributor1 - distributor ?depot2 - depot ?hoist2 - hoist
				?crate8 - crate)
			:precondition
				(and
					(at ?truck1 ?distributor1)
					(at ?hoist2 ?depot2)
					(available ?hoist2)
					(in ?crate8 ?truck1)
				)
			:effect
				(and
					(not (in ?crate8 ?truck1))
					(not (available ?hoist2))
					(lifting ?hoist2 ?crate8)
				)
;|			:permutation
;|				(drive ?truck1 ?distributor1 ?depot2)
;|				(unload ?hoist2 ?crate8 ?truck1 ?depot2)
;|				(drive ?truck1 ?depot2 ?distributor1)
		)
;|	)
;|	(:macro
		(:action chunk-23-0
			:parameters (?hoist1 - hoist ?crate6 - crate ?pallet1 - pallet ?depot1 - depot
				?truck0 - truck)
			:precondition
				(and
					(at ?hoist1 ?depot1)
					(at ?pallet1 ?depot1)
					(clear ?pallet1)
					(lifting ?hoist1 ?crate6)
					(in ?crate6 ?truck0)
					(at ?truck0 ?depot1)
				)
			:effect
				(and
					(at ?crate6 ?depot1)
					(not (clear ?pallet1))
					(clear ?crate6)
					(on ?crate6 ?pallet1)
					(not (in ?crate6 ?truck0))
				)
;|			:permutation
;|				(drop ?hoist1 ?crate6 ?pallet1 ?depot1)
;|				(unload ?hoist1 ?crate6 ?truck0 ?depot1)
		)
;|	)
;|	(:macro
		(:action chunk-12-0
			:parameters (?hoist3 - hoist ?crate4 - crate ?pallet3 - pallet ?distributor1 - distributor
				?crate0 - crate ?truck0 - truck)
			:precondition
				(and
					(at ?hoist3 ?distributor1)
					(at ?pallet3 ?distributor1)
					(clear ?pallet3)
					(lifting ?hoist3 ?crate4)
					(in ?crate4 ?truck0)
					(at ?truck0 ?distributor1)
					(in ?crate0 ?truck0)
				)
			:effect
				(and
					(at ?crate4 ?distributor1)
					(not (clear ?pallet3))
					(on ?crate4 ?pallet3)
					(not (in ?crate0 ?truck0))
					(at ?crate0 ?distributor1)
					(clear ?crate0)
					(on ?crate0 ?crate4)
					(not (in ?crate4 ?truck0))
				)
;|			:permutation
;|				(drop ?hoist3 ?crate4 ?pallet3 ?distributor1)
;|				(unload ?hoist3 ?crate0 ?truck0 ?distributor1)
;|				(drop ?hoist3 ?crate0 ?crate4 ?distributor1)
;|				(unload ?hoist3 ?crate4 ?truck0 ?distributor1)
		)
;|	)
)

