
(define
	(domain depots)
	(:requirements
		:strips :typing
	)
	(:types
		place locatable - object
		depot distributor - place
		truck hoist surface - locatable
		pallet crate - surface
	)
	(:predicates
		(at ?x - locatable ?y - place)
		(on ?x - crate ?y - surface)
		(in ?x - crate ?y - truck)
		(lifting ?x - hoist ?y - crate)
		(available ?x - hoist)
		(clear ?x - surface)
	)
	(:action drive
		:parameters (?x - truck ?y ?z - place)
		:precondition
			(and (at ?x ?y))
		:effect
			(and
				(not (at ?x ?y))
				(at ?x ?z)
			)
	)
	(:action lift
		:parameters (?x - hoist ?y - crate ?z - surface ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(available ?x)
				(at ?y ?p)
				(on ?y ?z)
				(clear ?y)
			)
		:effect
			(and
				(not (at ?y ?p))
				(lifting ?x ?y)
				(not (clear ?y))
				(not (available ?x))
				(clear ?z)
				(not (on ?y ?z))
			)
	)
	(:action drop
		:parameters (?x - hoist ?y - crate ?z - surface ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(clear ?z)
				(lifting ?x ?y)
			)
		:effect
			(and
				(available ?x)
				(not (lifting ?x ?y))
				(at ?y ?p)
				(not (clear ?z))
				(clear ?y)
				(on ?y ?z)
			)
	)
	(:action load
		:parameters (?x - hoist ?y - crate ?z - truck ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(lifting ?x ?y)
			)
		:effect
			(and
				(not (lifting ?x ?y))
				(in ?y ?z)
				(available ?x)
			)
	)
	(:action unload
		:parameters (?x - hoist ?y - crate ?z - truck ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(available ?x)
				(in ?y ?z)
			)
		:effect
			(and
				(not (in ?y ?z))
				(not (available ?x))
				(lifting ?x ?y)
			)
	)
;|	(:macro
		(:action chunk-0-1-3
			:parameters (?hoist0 - hoist ?crate6 - crate ?truck0 - truck ?depot0 - depot
				?pallet0 - pallet)
			:precondition
				(and
					(at ?hoist0 ?depot0)
					(at ?truck0 ?depot0)
					(available ?hoist0)
					(in ?crate6 ?truck0)
					(clear ?pallet0)
					(at ?pallet0 ?depot0)
				)
			:effect
				(and
					(not (in ?crate6 ?truck0))
					(at ?crate6 ?depot0)
					(not (clear ?pallet0))
					(clear ?crate6)
					(on ?crate6 ?pallet0)
				)
;|			:permutation
;|				(unload ?hoist0 ?crate6 ?truck0 ?depot0)
;|				(drop ?hoist0 ?crate6 ?pallet0 ?depot0)
		)
;|	)
;|	(:macro
		(:action chunk-7-4-71
			:parameters (?hoist1 - hoist ?crate3 - crate ?pallet1 - pallet ?depot1 - depot
				?crate4 - crate ?truck0 - truck)
			:precondition
				(and
					(at ?hoist1 ?depot1)
					(at ?pallet1 ?depot1)
					(clear ?pallet1)
					(lifting ?hoist1 ?crate3)
					(in ?crate4 ?truck0)
					(at ?truck0 ?depot1)
				)
			:effect
				(and
					(available ?hoist1)
					(not (lifting ?hoist1 ?crate3))
					(at ?crate3 ?depot1)
					(not (clear ?pallet1))
					(on ?crate3 ?pallet1)
					(not (in ?crate4 ?truck0))
					(at ?crate4 ?depot1)
					(clear ?crate4)
					(on ?crate4 ?crate3)
				)
;|			:permutation
;|				(drop ?hoist1 ?crate3 ?pallet1 ?depot1)
;|				(unload ?hoist1 ?crate4 ?truck0 ?depot1)
;|				(drop ?hoist1 ?crate4 ?crate3 ?depot1)
		)
;|	)
;|	(:macro
		(:action chunk-28-1-244
			:parameters (?truck0 - truck ?distributor0 - distributor ?depot0 - depot ?truck1 - truck
				?distributor1 - distributor ?depot1 - depot)
			:precondition
				(and
					(at ?truck0 ?distributor0)
					(at ?truck1 ?depot0)
					(at ?truck1 ?distributor1)
				)
			:effect
				(and
					(not (at ?truck0 ?distributor0))
					(at ?truck0 ?depot0)
					(not (at ?truck1 ?depot0))
					(at ?truck1 ?distributor0)
					(not (at ?truck1 ?distributor1))
					(at ?truck1 ?depot1)
				)
;|			:permutation
;|				(drive ?truck0 ?distributor0 ?depot0)
;|				(drive ?truck1 ?depot0 ?distributor0)
;|				(drive ?truck1 ?distributor1 ?depot1)
		)
;|	)
)

