
(define
	(domain depots)
	(:requirements
		:strips :typing
	)
	(:types
		place locatable - object
		depot distributor - place
		truck hoist surface - locatable
		pallet crate - surface
	)
	(:predicates
		(at ?x - locatable ?y - place)
		(on ?x - crate ?y - surface)
		(in ?x - crate ?y - truck)
		(lifting ?x - hoist ?y - crate)
		(available ?x - hoist)
		(clear ?x - surface)
	)
	(:action drive
		:parameters (?x - truck ?y ?z - place)
		:precondition
			(and (at ?x ?y))
		:effect
			(and
				(not (at ?x ?y))
				(at ?x ?z)
			)
	)
	(:action lift
		:parameters (?x - hoist ?y - crate ?z - surface ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(available ?x)
				(at ?y ?p)
				(on ?y ?z)
				(clear ?y)
			)
		:effect
			(and
				(not (at ?y ?p))
				(lifting ?x ?y)
				(not (clear ?y))
				(not (available ?x))
				(clear ?z)
				(not (on ?y ?z))
			)
	)
	(:action drop
		:parameters (?x - hoist ?y - crate ?z - surface ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(clear ?z)
				(lifting ?x ?y)
			)
		:effect
			(and
				(available ?x)
				(not (lifting ?x ?y))
				(at ?y ?p)
				(not (clear ?z))
				(clear ?y)
				(on ?y ?z)
			)
	)
	(:action load
		:parameters (?x - hoist ?y - crate ?z - truck ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(lifting ?x ?y)
			)
		:effect
			(and
				(not (lifting ?x ?y))
				(in ?y ?z)
				(available ?x)
			)
	)
	(:action unload
		:parameters (?x - hoist ?y - crate ?z - truck ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(available ?x)
				(in ?y ?z)
			)
		:effect
			(and
				(not (in ?y ?z))
				(not (available ?x))
				(lifting ?x ?y)
			)
	)
;|	(:macro
		(:action chunk-25-3
			:parameters (?hoist0 - hoist ?crate2 - crate ?pallet0 - pallet ?depot0 - depot
				?crate6 - crate ?truck0 - truck)
			:precondition
				(and
					(at ?hoist0 ?depot0)
					(at ?pallet0 ?depot0)
					(clear ?pallet0)
					(lifting ?hoist0 ?crate2)
					(in ?crate6 ?truck0)
					(at ?truck0 ?depot0)
				)
			:effect
				(and
					(available ?hoist0)
					(not (lifting ?hoist0 ?crate2))
					(at ?crate2 ?depot0)
					(not (clear ?pallet0))
					(on ?crate2 ?pallet0)
					(not (in ?crate6 ?truck0))
					(at ?crate6 ?depot0)
					(clear ?crate6)
					(on ?crate6 ?crate2)
				)
;|			:permutation
;|				(drop ?hoist0 ?crate2 ?pallet0 ?depot0)
;|				(unload ?hoist0 ?crate6 ?truck0 ?depot0)
;|				(drop ?hoist0 ?crate6 ?crate2 ?depot0)
		)
;|	)
)

