
(define
	(domain depots)
	(:requirements
		:strips :typing
	)
	(:types
		place locatable - object
		depot distributor - place
		truck hoist surface - locatable
		pallet crate - surface
	)
	(:predicates
		(at ?x - locatable ?y - place)
		(on ?x - crate ?y - surface)
		(in ?x - crate ?y - truck)
		(lifting ?x - hoist ?y - crate)
		(available ?x - hoist)
		(clear ?x - surface)
	)
	(:action drive
		:parameters (?x - truck ?y ?z - place)
		:precondition
			(and (at ?x ?y))
		:effect
			(and
				(not (at ?x ?y))
				(at ?x ?z)
			)
	)
	(:action lift
		:parameters (?x - hoist ?y - crate ?z - surface ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(available ?x)
				(at ?y ?p)
				(on ?y ?z)
				(clear ?y)
			)
		:effect
			(and
				(not (at ?y ?p))
				(lifting ?x ?y)
				(not (clear ?y))
				(not (available ?x))
				(clear ?z)
				(not (on ?y ?z))
			)
	)
	(:action drop
		:parameters (?x - hoist ?y - crate ?z - surface ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(clear ?z)
				(lifting ?x ?y)
			)
		:effect
			(and
				(available ?x)
				(not (lifting ?x ?y))
				(at ?y ?p)
				(not (clear ?z))
				(clear ?y)
				(on ?y ?z)
			)
	)
	(:action load
		:parameters (?x - hoist ?y - crate ?z - truck ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(lifting ?x ?y)
			)
		:effect
			(and
				(not (lifting ?x ?y))
				(in ?y ?z)
				(available ?x)
			)
	)
	(:action unload
		:parameters (?x - hoist ?y - crate ?z - truck ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(available ?x)
				(in ?y ?z)
			)
		:effect
			(and
				(not (in ?y ?z))
				(not (available ?x))
				(lifting ?x ?y)
			)
	)
;|	(:macro
		(:action chunk-5-4-51
			:parameters (?hoist0 - hoist ?crate14 - crate ?truck1 - truck ?depot0 - depot
				?pallet0 - pallet)
			:precondition
				(and
					(at ?hoist0 ?depot0)
					(at ?truck1 ?depot0)
					(available ?hoist0)
					(in ?crate14 ?truck1)
					(clear ?pallet0)
					(at ?pallet0 ?depot0)
				)
			:effect
				(and
					(not (in ?crate14 ?truck1))
					(at ?crate14 ?depot0)
					(not (clear ?pallet0))
					(clear ?crate14)
					(on ?crate14 ?pallet0)
				)
;|			:permutation
;|				(unload ?hoist0 ?crate14 ?truck1 ?depot0)
;|				(drop ?hoist0 ?crate14 ?pallet0 ?depot0)
		)
;|	)
;|	(:macro
		(:action chunk-61-5-456
			:parameters (?hoist0 - hoist ?crate2 - crate ?pallet0 - pallet ?depot0 - depot
				?crate0 - crate)
			:precondition
				(and
					(at ?hoist0 ?depot0)
					(at ?pallet0 ?depot0)
					(clear ?pallet0)
					(lifting ?hoist0 ?crate2)
					(clear ?crate0)
					(at ?crate0 ?depot0)
					(on ?crate0 ?pallet0)
				)
			:effect
				(and
					(not (lifting ?hoist0 ?crate2))
					(at ?crate2 ?depot0)
					(clear ?crate2)
					(on ?crate2 ?pallet0)
					(not (at ?crate0 ?depot0))
					(lifting ?hoist0 ?crate0)
					(not (clear ?crate0))
					(not (on ?crate0 ?pallet0))
				)
;|			:permutation
;|				(drop ?hoist0 ?crate2 ?pallet0 ?depot0)
;|				(lift ?hoist0 ?crate0 ?pallet0 ?depot0)
		)
;|	)
;|	(:macro
		(:action chunk-25-2-221
			:parameters (?truck0 - truck ?depot1 - depot ?distributor0 - distributor ?hoist2 - hoist
				?crate4 - crate)
			:precondition
				(and
					(at ?truck0 ?depot1)
					(at ?hoist2 ?distributor0)
					(lifting ?hoist2 ?crate4)
				)
			:effect
				(and
					(not (lifting ?hoist2 ?crate4))
					(in ?crate4 ?truck0)
					(available ?hoist2)
				)
;|			:permutation
;|				(drive ?truck0 ?depot1 ?distributor0)
;|				(load ?hoist2 ?crate4 ?truck0 ?distributor0)
;|				(drive ?truck0 ?distributor0 ?depot1)
		)
;|	)
)

