
(define
	(domain parking)
	(:requirements
		:strips :typing
	)
	(:types
		car curb
	)
	(:predicates
		(at-curb ?car - car)
		(at-curb-num ?car - car ?curb - curb)
		(behind-car ?car ?front-car - car)
		(car-clear ?car - car)
		(curb-clear ?curb - curb)
	)
	(:action move-curb-to-curb
		:parameters (?car - car ?curbsrc ?curbdest - curb)
		:precondition
			(and
				(car-clear ?car)
				(curb-clear ?curbdest)
				(at-curb-num ?car ?curbsrc)
			)
		:effect
			(and
				(not (curb-clear ?curbdest))
				(curb-clear ?curbsrc)
				(at-curb-num ?car ?curbdest)
				(not (at-curb-num ?car ?curbsrc))
			)
	)
	(:action move-curb-to-car
		:parameters (?car - car ?curbsrc - curb ?cardest - car)
		:precondition
			(and
				(car-clear ?car)
				(car-clear ?cardest)
				(at-curb-num ?car ?curbsrc)
				(at-curb ?cardest)
			)
		:effect
			(and
				(not (car-clear ?cardest))
				(curb-clear ?curbsrc)
				(behind-car ?car ?cardest)
				(not (at-curb-num ?car ?curbsrc))
				(not (at-curb ?car))
			)
	)
	(:action move-car-to-curb
		:parameters (?car ?carsrc - car ?curbdest - curb)
		:precondition
			(and
				(car-clear ?car)
				(curb-clear ?curbdest)
				(behind-car ?car ?carsrc)
			)
		:effect
			(and
				(not (curb-clear ?curbdest))
				(car-clear ?carsrc)
				(at-curb-num ?car ?curbdest)
				(not (behind-car ?car ?carsrc))
				(at-curb ?car)
			)
	)
	(:action move-car-to-car
		:parameters (?car ?carsrc ?cardest - car)
		:precondition
			(and
				(car-clear ?car)
				(car-clear ?cardest)
				(behind-car ?car ?carsrc)
				(at-curb ?cardest)
			)
		:effect
			(and
				(not (car-clear ?cardest))
				(car-clear ?carsrc)
				(behind-car ?car ?cardest)
				(not (behind-car ?car ?carsrc))
			)
	)
;|	(:macro
		(:action chunk-0-2
			:parameters (?car_01 ?car_03 - car ?curb_1 ?curb_2 - curb)
			:precondition
				(and
					(car-clear ?car_01)
					(curb-clear ?curb_1)
					(behind-car ?car_01 ?car_03)
					(at-curb-num ?car_03 ?curb_2)
				)
			:effect
				(and
					(not (curb-clear ?curb_1))
					(car-clear ?car_03)
					(at-curb-num ?car_01 ?curb_1)
					(not (behind-car ?car_01 ?car_03))
					(at-curb ?car_01)
					(not (car-clear ?car_01))
					(curb-clear ?curb_2)
					(behind-car ?car_03 ?car_01)
					(not (at-curb-num ?car_03 ?curb_2))
					(not (at-curb ?car_03))
				)
;|			:permutation
;|				(move-car-to-curb ?car_01 ?car_03 ?curb_1)
;|				(move-curb-to-car ?car_03 ?curb_2 ?car_01)
		)
;|	)
)

