
(define
	(domain satellite)
	(:requirements
		:strips :typing
	)
	(:types
		satellite direction instrument mode
	)
	(:predicates
		(on_board ?i - instrument ?s - satellite)
		(supports ?i - instrument ?m - mode)
		(pointing ?s - satellite ?d - direction)
		(power_avail ?s - satellite)
		(power_on ?i - instrument)
		(calibrated ?i - instrument)
		(have_image ?d - direction ?m - mode)
		(calibration_target ?i - instrument ?d - direction)
	)
	(:action turn_to
		:parameters (?s - satellite ?d_new ?d_prev - direction)
		:precondition
			(and (pointing ?s ?d_prev))
		:effect
			(and
				(pointing ?s ?d_new)
				(not (pointing ?s ?d_prev))
			)
	)
	(:action switch_on
		:parameters (?i - instrument ?s - satellite)
		:precondition
			(and
				(on_board ?i ?s)
				(power_avail ?s)
			)
		:effect
			(and
				(power_on ?i)
				(not (calibrated ?i))
				(not (power_avail ?s))
			)
	)
	(:action switch_off
		:parameters (?i - instrument ?s - satellite)
		:precondition
			(and
				(on_board ?i ?s)
				(power_on ?i)
			)
		:effect
			(and
				(not (power_on ?i))
				(power_avail ?s)
			)
	)
	(:action calibrate
		:parameters (?s - satellite ?i - instrument ?d - direction)
		:precondition
			(and
				(on_board ?i ?s)
				(calibration_target ?i ?d)
				(pointing ?s ?d)
				(power_on ?i)
			)
		:effect
			(and (calibrated ?i))
	)
	(:action take_image
		:parameters (?s - satellite ?d - direction ?i - instrument ?m - mode)
		:precondition
			(and
				(calibrated ?i)
				(on_board ?i ?s)
				(supports ?i ?m)
				(power_on ?i)
				(pointing ?s ?d)
			)
		:effect
			(and (have_image ?d ?m))
	)
;|	(:macro
		(:action chunk-15-0
			:parameters (?satellite1 - satellite ?instrument2 - instrument ?star0 - direction)
			:precondition
				(and
					(on_board ?instrument2 ?satellite1)
					(calibration_target ?instrument2 ?star0)
					(pointing ?satellite1 ?star0)
					(power_on ?instrument2)
					(power_avail ?satellite1)
				)
			:effect
				(and
					(calibrated ?instrument2)
					(power_on ?instrument2)
					(not (power_avail ?satellite1))
				)
;|			:permutation
;|				(calibrate ?satellite1 ?instrument2 ?star0)
;|				(switch_on ?instrument2 ?satellite1)
;|				(calibrate ?satellite1 ?instrument2 ?star0)
		)
;|	)
)

