
(define
	(domain satellite)
	(:requirements
		:strips :typing
	)
	(:types
		satellite direction instrument mode
	)
	(:predicates
		(on_board ?i - instrument ?s - satellite)
		(supports ?i - instrument ?m - mode)
		(pointing ?s - satellite ?d - direction)
		(power_avail ?s - satellite)
		(power_on ?i - instrument)
		(calibrated ?i - instrument)
		(have_image ?d - direction ?m - mode)
		(calibration_target ?i - instrument ?d - direction)
	)
	(:action turn_to
		:parameters (?s - satellite ?d_new ?d_prev - direction)
		:precondition
			(and (pointing ?s ?d_prev))
		:effect
			(and
				(pointing ?s ?d_new)
				(not (pointing ?s ?d_prev))
			)
	)
	(:action switch_on
		:parameters (?i - instrument ?s - satellite)
		:precondition
			(and
				(on_board ?i ?s)
				(power_avail ?s)
			)
		:effect
			(and
				(power_on ?i)
				(not (calibrated ?i))
				(not (power_avail ?s))
			)
	)
	(:action switch_off
		:parameters (?i - instrument ?s - satellite)
		:precondition
			(and
				(on_board ?i ?s)
				(power_on ?i)
			)
		:effect
			(and
				(not (power_on ?i))
				(power_avail ?s)
			)
	)
	(:action calibrate
		:parameters (?s - satellite ?i - instrument ?d - direction)
		:precondition
			(and
				(on_board ?i ?s)
				(calibration_target ?i ?d)
				(pointing ?s ?d)
				(power_on ?i)
			)
		:effect
			(and (calibrated ?i))
	)
	(:action take_image
		:parameters (?s - satellite ?d - direction ?i - instrument ?m - mode)
		:precondition
			(and
				(calibrated ?i)
				(on_board ?i ?s)
				(supports ?i ?m)
				(power_on ?i)
				(pointing ?s ?d)
			)
		:effect
			(and (have_image ?d ?m))
	)
;|	(:macro
		(:action chunk-6-0
			:parameters (?satellite0 - satellite ?groundstation0 ?phenomenon20 - direction ?instrument0 - instrument
				?star0 - direction)
			:precondition
				(and
					(pointing ?satellite0 ?phenomenon20)
					(on_board ?instrument0 ?satellite0)
					(calibration_target ?instrument0 ?star0)
					(pointing ?satellite0 ?star0)
					(power_on ?instrument0)
					(calibration_target ?instrument0 ?groundstation0)
					(power_avail ?satellite0)
				)
			:effect
				(and
					(pointing ?satellite0 ?groundstation0)
					(not (pointing ?satellite0 ?phenomenon20))
					(calibrated ?instrument0)
					(power_on ?instrument0)
					(not (power_avail ?satellite0))
				)
;|			:permutation
;|				(turn_to ?satellite0 ?groundstation0 ?phenomenon20)
;|				(calibrate ?satellite0 ?instrument0 ?star0)
;|				(switch_on ?instrument0 ?satellite0)
;|				(calibrate ?satellite0 ?instrument0 ?groundstation0)
		)
;|	)
;|	(:macro
		(:action chunk-6-2
			:parameters (?satellite0 - satellite ?instrument0 - instrument ?star0 ?star2 - direction
				?image2 - mode)
			:precondition
				(and
					(on_board ?instrument0 ?satellite0)
					(calibration_target ?instrument0 ?star0)
					(pointing ?satellite0 ?star0)
					(power_on ?instrument0)
					(supports ?instrument0 ?image2)
				)
			:effect
				(and
					(calibrated ?instrument0)
					(pointing ?satellite0 ?star2)
					(not (pointing ?satellite0 ?star0))
					(have_image ?star2 ?image2)
				)
;|			:permutation
;|				(calibrate ?satellite0 ?instrument0 ?star0)
;|				(turn_to ?satellite0 ?star2 ?star0)
;|				(take_image ?satellite0 ?star2 ?instrument0 ?image2)
		)
;|	)
;|	(:macro
		(:action chunk-7-1
			:parameters (?satellite0 - satellite ?instrument0 - instrument ?star0 ?star2 - direction)
			:precondition
				(and
					(on_board ?instrument0 ?satellite0)
					(calibration_target ?instrument0 ?star0)
					(pointing ?satellite0 ?star0)
					(power_on ?instrument0)
				)
			:effect
				(and
					(calibrated ?instrument0)
					(pointing ?satellite0 ?star2)
					(not (pointing ?satellite0 ?star0))
				)
;|			:permutation
;|				(calibrate ?satellite0 ?instrument0 ?star0)
;|				(turn_to ?satellite0 ?star2 ?star0)
		)
;|	)
;|	(:macro
		(:action chunk-0-2
			:parameters (?satellite0 - satellite ?star2 - direction ?instrument0 - instrument ?image2 - mode
				?star5 - direction)
			:precondition
				(and
					(calibrated ?instrument0)
					(on_board ?instrument0 ?satellite0)
					(supports ?instrument0 ?image2)
					(power_on ?instrument0)
					(pointing ?satellite0 ?star2)
				)
			:effect
				(and
					(have_image ?star2 ?image2)
					(pointing ?satellite0 ?star5)
					(not (pointing ?satellite0 ?star2))
					(have_image ?star5 ?image2)
				)
;|			:permutation
;|				(take_image ?satellite0 ?star2 ?instrument0 ?image2)
;|				(turn_to ?satellite0 ?star5 ?star2)
;|				(take_image ?satellite0 ?star5 ?instrument0 ?image2)
		)
;|	)
)

