
(define
	(domain tpp-propositional)
	(:requirements
		:strips :typing
	)
	(:types
		place locatable level - object
		depot market - place
		truck goods - locatable
	)
	(:predicates
		(loaded ?g - goods ?t - truck ?l - level)
		(ready-to-load ?g - goods ?m - market ?l - level)
		(stored ?g - goods ?l - level)
		(on-sale ?g - goods ?m - market ?l - level)
		(next ?l1 ?l2 - level)
		(at ?t - truck ?p - place)
		(connected ?p1 ?p2 - place)
	)
	(:action drive
		:parameters (?t - truck ?from ?to - place)
		:precondition
			(and
				(at ?t ?from)
				(connected ?from ?to)
			)
		:effect
			(and
				(not (at ?t ?from))
				(at ?t ?to)
			)
	)
	(:action load
		:parameters (?g - goods ?t - truck ?m - market ?l1
			?l2 ?l3 ?l4 - level)
		:precondition
			(and
				(at ?t ?m)
				(loaded ?g ?t ?l3)
				(ready-to-load ?g ?m ?l2)
				(next ?l2 ?l1)
				(next ?l4 ?l3)
			)
		:effect
			(and
				(loaded ?g ?t ?l4)
				(not (loaded ?g ?t ?l3))
				(ready-to-load ?g ?m ?l1)
				(not (ready-to-load ?g ?m ?l2))
			)
	)
	(:action unload
		:parameters (?g - goods ?t - truck ?d - depot ?l1
			?l2 ?l3 ?l4 - level)
		:precondition
			(and
				(at ?t ?d)
				(loaded ?g ?t ?l2)
				(stored ?g ?l3)
				(next ?l2 ?l1)
				(next ?l4 ?l3)
			)
		:effect
			(and
				(loaded ?g ?t ?l1)
				(not (loaded ?g ?t ?l2))
				(stored ?g ?l4)
				(not (stored ?g ?l3))
			)
	)
	(:action buy
		:parameters (?t - truck ?g - goods ?m - market ?l1
			?l2 ?l3 ?l4 - level)
		:precondition
			(and
				(at ?t ?m)
				(on-sale ?g ?m ?l2)
				(ready-to-load ?g ?m ?l3)
				(next ?l2 ?l1)
				(next ?l4 ?l3)
			)
		:effect
			(and
				(on-sale ?g ?m ?l1)
				(not (on-sale ?g ?m ?l2))
				(ready-to-load ?g ?m ?l4)
				(not (ready-to-load ?g ?m ?l3))
			)
	)
;|	(:macro
		(:action chunk-0-1-7
			:parameters (?truck3 - truck ?market1 ?market6 - market ?depot4 - depot)
			:precondition
				(and
					(at ?truck3 ?market1)
					(connected ?market1 ?market6)
					(connected ?market6 ?depot4)
				)
			:effect
				(and
					(not (at ?truck3 ?market1))
					(at ?truck3 ?depot4)
				)
;|			:permutation
;|				(drive ?truck3 ?market1 ?market6)
;|				(drive ?truck3 ?market6 ?depot4)
		)
;|	)
;|	(:macro
		(:action chunk-14-1-135
			:parameters (?truck2 - truck ?depot1 - depot ?market5 - market ?truck3 - truck
				?market4 - market)
			:precondition
				(and
					(at ?truck2 ?depot1)
					(connected ?depot1 ?market5)
					(at ?truck3 ?depot1)
					(connected ?market4 ?depot1)
					(at ?truck3 ?market4)
				)
			:effect
				(and
					(not (at ?truck2 ?depot1))
					(at ?truck2 ?market5)
					(at ?truck3 ?market5)
					(not (at ?truck3 ?market4))
				)
;|			:permutation
;|				(drive ?truck2 ?depot1 ?market5)
;|				(drive ?truck3 ?depot1 ?market5)
;|				(drive ?truck3 ?market4 ?depot1)
		)
;|	)
;|	(:macro
		(:action chunk-18-2-162
			:parameters (?truck2 - truck ?depot1 - depot ?market5 - market ?depot3 - depot
				?truck3 - truck ?market4 - market)
			:precondition
				(and
					(at ?truck2 ?depot1)
					(connected ?depot1 ?market5)
					(connected ?market5 ?depot3)
					(at ?truck3 ?depot1)
					(connected ?market4 ?depot1)
					(at ?truck3 ?market4)
				)
			:effect
				(and
					(not (at ?truck2 ?depot1))
					(at ?truck2 ?depot3)
					(at ?truck3 ?market5)
					(not (at ?truck3 ?market4))
				)
;|			:permutation
;|				(drive ?truck2 ?depot1 ?market5)
;|				(drive ?truck2 ?market5 ?depot3)
;|				(drive ?truck3 ?depot1 ?market5)
;|				(drive ?truck3 ?market4 ?depot1)
		)
;|	)
)

